# Messages

GSM_Error GSM_DecodePDUFrame(GSM_Debug_Info *di, GSM_SMSMessage *SMS, const unsigned char *buffer, size_t length, size_t *final_pos, gboolean SMSC)

  Decodes PDU data.

  Parameters:

    - di – Debug information structure.

    - SMS – Pointer where to store parsed message.

    - buffer – PDU data.

    - length – Length of PDU data.

    - final_pos – Optional pointer where end position will be stored.

    - SMSC – Whether PDU includes SMSC data.

GSM_Error GSM_DecodeSMSFrame(GSM_Debug_Info *di, GSM_SMSMessage *SMS, unsigned char *buffer, GSM_SMSMessageLayout Layout)

  Decodes SMS frame.

GSM_Coding_Type GSM_GetMessageCoding(GSM_Debug_Info *di, const char TPDCS)

  Finds out coding type based on TPDCS header byte as defined by GSM 03.38.

GSM_Error GSM_EncodeSMSFrame(GSM_Debug_Info *di, GSM_SMSMessage *SMS, unsigned char *buffer, GSM_SMSMessageLayout Layout, int *length, gboolean clear)

  Encodes SMS frame.

GSM_Error GSM_DecodeSMSFrameStatusReportData(GSM_Debug_Info *di, GSM_SMSMessage *SMS, unsigned char *buffer, GSM_SMSMessageLayout Layout)

  Decodes SMS frame for status report.

GSM_Error GSM_DecodeSMSFrameText(GSM_Debug_Info *di, GSM_SMSMessage *SMS, unsigned char *buffer, GSM_SMSMessageLayout Layout)

  Decodes SMS frame in textual representation.

void GSM_DecodeUDHHeader(GSM_Debug_Info *di, GSM_UDHHeader *UDH)

  Decodes UDH header.

void GSM_EncodeUDHHeader(GSM_Debug_Info *di, GSM_UDHHeader *UDH)

  Encodes UDH header.

void GSM_SetDefaultReceivedSMSData(GSM_SMSMessage *SMS)

  Sets default content for SMS except for changing locations. Use this for clearing structure while keeping location of message.

  Parameters:

    - SMS – Pointer to structure which should be cleaned up.

void GSM_SetDefaultSMSData(GSM_SMSMessage *SMS)

  Sets default content for SMS. Use this for clearing structure.

  Parameters:

    - SMS – Pointer to structure which should be cleaned up.

gboolean GSM_DecodeSiemensOTASMS(GSM_Debug_Info *di, GSM_SiemensOTASMSInfo *Info, GSM_SMSMessage *SMS)

  Decodes Siemens OTA data.

GSM_Error PHONE_EncodeSMSFrame(GSM_StateMachine *s, GSM_SMSMessage *SMS, unsigned char *buffer, GSM_SMSMessageLayout Layout, int *length, gboolean clear)

  Encodes SMS frame according to layout.

  Returns:

    Error code.

GSM_Error GSM_EncodeMultiPartSMS(GSM_Debug_Info *di, GSM_MultiPartSMSInfo *Info, GSM_MultiSMSMessage *SMS)

  Encodes multi part SMS from “readable” format.

  Returns:

    Error code.

gboolean GSM_DecodeMultiPartSMS(GSM_Debug_Info *di, GSM_MultiPartSMSInfo *Info, GSM_MultiSMSMessage *SMS, gboolean ems)

  Decodes multi part SMS to “readable” format.

void GSM_ClearMultiPartSMSInfo(GSM_MultiPartSMSInfo *Info)

  Clears GSM_MultiPartSMSInfo to default values.

void GSM_FreeMultiPartSMSInfo(GSM_MultiPartSMSInfo *Info)

  Frees any allocated structures inside GSM_MultiPartSMSInfo.

GSM_Error GSM_LinkSMS(GSM_Debug_Info *di, GSM_MultiSMSMessage **INPUT, GSM_MultiSMSMessage **OUTPUT, gboolean ems)

  Links SMS messages according to IDs.

  Returns:

    Error code.

GSM_Error GSM_DecodeMMSFileToMultiPart(GSM_Debug_Info *di, GSM_File *file, GSM_EncodedMultiPartMMSInfo *info)

  Decodes MMS data.

GSM_Error GSM_ClearMMSMultiPart(GSM_EncodedMultiPartMMSInfo *info)

  Clears MMS data, used to initialize structure.

GSM_Error GSM_GetSMSC(GSM_StateMachine *s, GSM_SMSC *smsc)

  Gets SMS Service Center number and SMS settings.

  Parameters:

    - s – State machine pointer.

    - smsc – [inout] SMSC structure, should contain location.

  Returns:

    Error code.

GSM_Error GSM_SetSMSC(GSM_StateMachine *s, GSM_SMSC *smsc)

  Sets SMS Service Center number and SMS settings.

  Parameters:

    - s – State machine pointer.

    - smsc – [in] SMSC structure.

  Returns:

    Error code.

GSM_Error GSM_GetSMSStatus(GSM_StateMachine *s, GSM_SMSMemoryStatus *status)

  Gets information about SMS memory (read/unread/size of memory for both SIM and phone).

  Parameters:

    - s – State machine pointer.

    - status – [out] Pointer to SMS status structure.

  Returns:

    Error code.

GSM_Error GSM_GetSMS(GSM_StateMachine *s, GSM_MultiSMSMessage *sms)

  Reads SMS message.

  Parameters:

    - s – State machine pointer.

    - sms – [inout] SMS message data read from phone, location and folder should be set.

  Returns:

    Error code.

GSM_Error GSM_GetNextSMS(GSM_StateMachine *s, GSM_MultiSMSMessage *sms, gboolean start)

  Reads next (or first if start set) SMS message. This might be faster for some phones than using GSM_GetSMS for each message.

  Please note that this commend does not have to mark message as read in phone. To do so, you have to call GSM_GetSMS.

  Parameters:

    - s – State machine pointer.

    - sms – [inout] SMS message data read from phone, for subsequent reads, location and folder might be used by phone driver to determine reading state.

    - start – [in] Whether we start reading from beginning.

  Returns:

    Error code.

GSM_Error GSM_SetSMS(GSM_StateMachine *s, GSM_SMSMessage *sms)

  Sets SMS.

  Parameters:

    - s – State machine pointer.

    - sms – [in] SMS message data.

  Returns:

    Error code.

GSM_Error GSM_AddSMS(GSM_StateMachine *s, GSM_SMSMessage *sms)

  Adds SMS to specified folder.

  Parameters:

    - s – State machine pointer.

    - sms – [inout] SMS message data, location will be updated.

  Returns:

    Error code.

GSM_Error GSM_DeleteSMS(GSM_StateMachine *s, GSM_SMSMessage *sms)

  Deletes SMS.

  Parameters:

    - s – State machine pointer.

    - sms – [in] SMS structure with SMS location and folder.

  Returns:

    Error code.

GSM_Error GSM_SendSMS(GSM_StateMachine *s, GSM_SMSMessage *sms)

  Sends SMS.

  Parameters:

    - s – State machine pointer.

    - sms – [in] SMS structure with SMS data to send.

  Returns:

    Error code.

GSM_Error GSM_SendSavedSMS(GSM_StateMachine *s, int Folder, int Location)

  Sends SMS already saved in phone.

  Parameters:

    - s – State machine pointer.

    - Folder – [in] Folder, where message is stored.

    - Location – [in] Location, where message is stored.

  Returns:

    Error code.

GSM_Error GSM_SetFastSMSSending(GSM_StateMachine *s, gboolean enable)

  Configures fast SMS sending.

  Parameters:

    - s – State machine pointer.

    - enable – [in] Whether to enable notifications.

  Returns:

    Error code.

GSM_Error GSM_SetIncomingSMS(GSM_StateMachine *s, gboolean enable)

  Enable/disable notification on incoming SMS.

  Parameters:

    - s – State machine pointer.

    - enable – [in] Whether to enable notifications.

  Returns:

    Error code.

GSM_Error GSM_SetIncomingCB(GSM_StateMachine *s, gboolean enable)

  Gets network information from phone.

  Parameters:

    - s – State machine pointer.

    - enable – [in] Whether to enable notifications.

  Returns:

    Error code.

GSM_Error GSM_GetSMSFolders(GSM_StateMachine *s, GSM_SMSFolders *folders)

  Returns SMS folders information.

  Parameters:

    - s – State machine pointer.

    - folders – [out] folders Pointer to folders structure, which will be filled in.

  Returns:

    Error code.

GSM_Error GSM_AddSMSFolder(GSM_StateMachine *s, unsigned char *name)

  Creates SMS folder.

  Parameters:

    - s – State machine pointer.

    - name – [in] Name of SMS folder which should be created.

  Returns:

    Error code.

GSM_Error GSM_DeleteSMSFolder(GSM_StateMachine *s, int ID)

  Deletes SMS folder.

  Parameters:

    - s – State machine pointer.

    - ID – [in] ID of SMS folder to delete.

  Returns:

    Error code.

GSM_Error GSM_GetMMSFolders(GSM_StateMachine *s, GSM_MMSFolders *folders)

  Lists MMS folders.

  Parameters:

    - s – State machine pointer.

    - folders – Pointer to structure, whehe folder information will be stored.

  Returns:

    Error code.

GSM_Error GSM_GetNextMMSFileInfo(GSM_StateMachine *s, unsigned char *FileID, int *MMSFolder, gboolean start)

  Retrieves next part of MMS file information.

  Parameters:

    - s – State machine pointer.

    - FileID – [inout] File ID will be stored here, might be used for consequent reads.

    - MMSFolder – [inout] MMS folder ID will be stored here, might be used for consequent reads.

    - start – [in] Whether to start reading.

  Returns:

    Error code.

GSM_Error GSM_SetIncomingUSSD(GSM_StateMachine *s, gboolean enable)

  Activates/deactivates noticing about incoming USSDs (UnStructured Supplementary Services).

  Parameters:

    - s – State machine pointer.

    - enable – [in] Whether to enable notifications.

  Returns:

    Error code.

void GSM_SMSCounter(GSM_Debug_Info *di, unsigned char *MessageBuffer, GSM_UDH UDHType, GSM_Coding_Type Coding, int *SMSNum, size_t *CharsLeft)

  Calculates number of messages and free chars needed for text.

  Parameters:

    - di – Debug settings.

    - MessageBuffer – [in] Actual message text in unicode.

    - UDHType – [in] UDH type.

    - Coding – [in] GSM Encoding type.

    - SMSNum – [out] Number of messages needed to store the text.

    - CharsLeft – [out] Number of free chars in the message.

enum GSM_MMS_Class

  MMS message class.

  Values:

  enumerator GSM_MMS_None

    None class specified.

  enumerator GSM_MMS_Personal

    Personal message.

  enumerator GSM_MMS_Advertisement

    Advertisement message.

  enumerator GSM_MMS_Info

    Informational message.

  enumerator GSM_MMS_Auto

    Automatic message class.

  enumerator GSM_MMS_INVALID

struct GSM_MMSIndicator

  MMS indicator data.

  Public Members

  char Address[500]

    Message address (URL for download).

  char Title[200]

    Message title (subject).

  char Sender[200]

    Message sender.

  size_t MessageSize

    Message size, if 0 it won’t be decoded or was not decoded.

  GSM_MMS_Class Class

    Class of a message.

struct GSM_CBMessage

  Structure for Cell Broadcast messages.

  Public Members

  int Channel

    Channel number.

  char Text[300]

    Message text.

enum GSM_USSDStatus

  Status of USSD message.

  Values:

  enumerator USSD_Unknown

    Unknown status

  enumerator USSD_NoActionNeeded

    No action is needed, maybe network initiated USSD

  enumerator USSD_ActionNeeded

    Reply is expected

  enumerator USSD_Terminated

    USSD dialog terminated

  enumerator USSD_AnotherClient

    Another client replied

  enumerator USSD_NotSupported

    Operation not supported

  enumerator USSD_Timeout

    Network timeout

struct GSM_USSDMessage

  Structure for USSD messages.

  Public Members

  unsigned char Text[2 * (GSM_MAX_USSD_LENGTH + 1)]

    Message text.

  GSM_USSDStatus Status

    Message status.

struct GSM_SMSMemoryStatus

  Status of SMS memory.

  Public Members

  int SIMUnRead

    Number of unread messages on SIM.

  int SIMUsed

    Number of all saved messages (including unread) on SIM.

  int SIMSize

    Number of all possible messages on SIM.

  int TemplatesUsed

    Number of used templates (62xx/63xx/7110/etc.).

  int PhoneUnRead

    Number of unread messages in phone.

  int PhoneUsed

    Number of all saved messages in phone.

  int PhoneSize

    Number of all possible messages on phone.

enum GSM_SMSFormat

  Enum defines format of SMS messages. See GSM 03.40 section 9.2.3.9

  Values:

  enumerator SMS_FORMAT_Pager
  enumerator SMS_FORMAT_Fax
  enumerator SMS_FORMAT_Email
  enumerator SMS_FORMAT_Text

enum GSM_ValidityPeriod

  Enum defines some the most often used validity lengths for SMS messages for relative validity format. See GSM 03.40 section 9.2.3.12.1 - it gives more values.

  Values:

  enumerator SMS_VALID_1_Hour
  enumerator SMS_VALID_6_Hours
  enumerator SMS_VALID_1_Day
  enumerator SMS_VALID_3_Days
  enumerator SMS_VALID_1_Week
  enumerator SMS_VALID_Max_Time

enum GSM_ValidityPeriodFormat

  Enum defines format of validity period for SMS messages. See GSM 03.40 section 9.2.3.12

  Values:

  enumerator SMS_Validity_NotAvailable
  enumerator SMS_Validity_RelativeFormat

struct GSM_SMSValidity

  Structure for validity of SMS messages

  Public Members

  GSM_ValidityPeriod Relative

    Value defines period for relative format

struct GSM_SMSC

  Structure for SMSC (SMS Center) information.

  Public Members

  int Location

    Number of the SMSC on SIM

  unsigned char Name[(GSM_MAX_SMSC_NAME_LENGTH + 1) * 2]

    Name of the SMSC

  unsigned char Number[(GSM_MAX_NUMBER_LENGTH + 1) * 2]

    SMSC phone number.

  GSM_SMSValidity Validity

    Validity of SMS messages.

  GSM_SMSFormat Format

    Format of sent SMS messages.

  unsigned char DefaultNumber[(GSM_MAX_NUMBER_LENGTH + 1) * 2]

    Default recipient number. In old DCT3 ignored

enum GSM_SMS_State

  Status of SMS message.

  Values:

  enumerator SMS_Sent
  enumerator SMS_UnSent
  enumerator SMS_Read
  enumerator SMS_UnRead

enum GSM_Coding_Type

  Coding type of SMS.

  Values:

  enumerator SMS_Coding_Unicode_No_Compression

    Unicode

  enumerator SMS_Coding_Unicode_Compression
  enumerator SMS_Coding_Default_No_Compression

    Default GSM alphabet.

  enumerator SMS_Coding_Default_Compression
  enumerator SMS_Coding_8bit

    8-bit.

enum GSM_UDH

  Types of UDH (User Data Header).

  Values:

  enumerator UDH_NoUDH
  enumerator UDH_ConcatenatedMessages

    Linked SMS.

  enumerator UDH_ConcatenatedMessages16bit

    Linked SMS with 16 bit reference.

  enumerator UDH_DisableVoice
  enumerator UDH_DisableFax
  enumerator UDH_DisableEmail
  enumerator UDH_EnableVoice
  enumerator UDH_EnableFax
  enumerator UDH_EnableEmail
  enumerator UDH_VoidSMS
  enumerator UDH_NokiaRingtone
  enumerator UDH_NokiaRingtoneLong
  enumerator UDH_NokiaOperatorLogo
  enumerator UDH_NokiaOperatorLogoLong
  enumerator UDH_NokiaCallerLogo
  enumerator UDH_NokiaWAP
  enumerator UDH_NokiaWAPLong
  enumerator UDH_NokiaCalendarLong
  enumerator UDH_NokiaProfileLong
  enumerator UDH_NokiaPhonebookLong
  enumerator UDH_UserUDH
  enumerator UDH_MMSIndicatorLong

struct GSM_UDHHeader

  Structure for User Data Header.

  Public Members

  GSM_UDH Type

    UDH type.

  int Length

    UDH length.

  unsigned char Text[GSM_MAX_UDH_LENGTH]

    UDH text.

  int ID8bit

    8-bit ID, when required (-1 otherwise).

  int ID16bit

    16-bit ID, when required (-1 otherwise).

  int PartNumber

    Number of current part.

  int AllParts

    Total number of parts.

enum GSM_SMSMessageType

  TP-Message-Type-Indicator. See GSM 03.40 section 9.2.3.1.

  Values:

  enumerator SMS_Deliver

    SMS in Inbox.

  enumerator SMS_Status_Report

    Delivery Report

  enumerator SMS_Submit

    SMS for sending or in Outbox

struct GSM_SMSMessage

  SMS message data.

  Public Members

  unsigned char ReplaceMessage

    Message to be replaced.

  gboolean RejectDuplicates

    Whether to reject duplicates.

  GSM_UDHHeader UDH

    UDH (User Data Header)

  unsigned char Number[(GSM_MAX_NUMBER_LENGTH + 1) * 2]

    Sender or recipient number.

  GSM_SMSC SMSC

    SMSC (SMS Center)

  GSM_MemoryType Memory

    For saved SMS: where exactly it’s saved (SIM/phone)

  int Location

    For saved SMS: location of SMS in memory.

  int Folder

    For saved SMS: number of folder, where SMS is saved

  gboolean InboxFolder

    For saved SMS: whether SMS is really in Inbox.

  int Length

    Length of the SMS message.

  GSM_SMS_State State

    Status (read/unread/…) of SMS message.

  unsigned char Name[(GSM_MAX_SMS_NAME_LENGTH + 1) * 2]

    Name in Nokia with SMS memory (6210/7110, etc.) Ignored in other.

  unsigned char Text[(GSM_MAX_SMS_LENGTH + 1) * 2]

    Text for SMS.

  GSM_SMSMessageType PDU

    Type of message.

  GSM_Coding_Type Coding

    Type of coding.

  GSM_DateTime DateTime

    Date and time, when SMS was saved or sent

  GSM_DateTime SMSCTime

    Date of SMSC response in DeliveryReport messages.

  unsigned char DeliveryStatus

    In delivery reports: status.

  gboolean ReplyViaSameSMSC

    Indicates whether “Reply via same center” is set.

  signed char Class

    SMS class (0 is flash SMS, 1 is normal one).

  unsigned char MessageReference

    Message reference.

struct GSM_SMSMessageLayout

  Public Members

  unsigned char Text

    TP-User-Data. GSM 03.40 section 9.2.3.24.

  unsigned char Number

    - In SMS-Deliver: TP-Originating-Address. GSM 03.40 section 9.2.3.7.

    - In SMS-Submit: TP-Destination-Address. GSM 03.40 section 9.2.3.8.

    - In SMS-Status-Report: TP-Recipient-Address. GSM 03.40 section 9.2.3.14.

  unsigned char SMSCNumber

    SMSC number

  unsigned char TPDCS

    TP-Data-Coding-Scheme. GSM 03.40 section 9.2.3.10. Contains alphabet type, SMS class (and some others)

  unsigned char DateTime

    - For SMS-Submit: TP-Validity-Period. GSM 03.40 section 9.2.3.12.

    - For SMS-Status-Report: TP-Discharge Time. GSM 03.40 section 9.2.3.13.

  unsigned char SMSCTime

    TP-Service-Centre-Time-Stamp in SMS-Status-Report. GSM 03.40 section 9.2.3.11.

  unsigned char TPStatus

    TP-Status in SMS-Status-Report. GSM 03.40 section 9.2.3.15.

  unsigned char TPUDL

    TP-User-Data-Length. GSM 03.40 section 9.2.3.16.

  unsigned char TPVP

    TP-Validity Period in SMS-Submit. GSM 03.40 section 9.2.3.12.

  unsigned char firstbyte

    Byte contains in SMS-Deliver:

    - TP-Message-Type-Indicator (2 bits) GSM 03.40 section 9.2.3.1

    - TP-More-Messages-To-Send (1 bit). GSM 03.40 section 9.2.3.2

    - TP-Reply-Path (1 bit). GSM 03.40 section 9.2.3.17

    - TP-User-Data-Header-Indicator (1 bit). GSM 03.40 section 9.2.3.23

    - TP-Status-Report-Indicator (1 bit). GSM 03.40 section 9.2.3.4

    Byte contains in SMS-Submit:

    - TP-Message-Type-Indicator (2 bits) GSM 03.40 section 9.2.3.1

    - TP-Reject-Duplicates (1 bit). GSM 03.40 section

    - TP-Validity-Period-Format (2 bits).GSM 03.40 section 9.2.3.3

    - TP-Reply-Path (1 bit). GSM 03.40 section 9.2.3.17

    - TP-User-Data-Header-Indicator (1 bit). GSM 03.40 section 9.2.3.23

    - TP-Status-Report-Request (1 bit). GSM 03.40 section 9.2.3.5

  unsigned char TPMR

    TP-Message Reference in SMS-Submit. GSM 03.40 section 9.2.3.6

  unsigned char TPPID

    TP-Protocol-Identifier. GSM 03.40 section 9.2.3.9

struct GSM_OneSMSFolder

  Information about SMS folder.

  Public Members

  gboolean InboxFolder

    Whether it is inbox.

  gboolean OutboxFolder

    Whether it is outbox.

  GSM_MemoryType Memory

    Where exactly it’s saved.

  unsigned char Name[(GSM_MAX_SMS_FOLDER_NAME_LEN + 1) * 2]

    Name of the folder

struct GSM_SMSFolders

  List of SMS folders.

  Public Members

  GSM_OneSMSFolder Folder[GSM_MAX_SMS_FOLDERS]

    Array of structures holding information about each folder.

  int Number

    Number of SMS folders.

struct GSM_SiemensOTASMSInfo

  Siemens OTA data.

struct GSM_MultiSMSMessage

  Multiple SMS messages, used for Smart Messaging 3.0/EMS.

  Public Members

  int Number

    Number of messages.

  GSM_SMSMessage SMS[GSM_MAX_MULTI_SMS]

    Array of SMSes.

  gboolean Processed

    Boolean flag for processing

struct GSM_OneMMSFolder

  Information about MMS folder.

  Public Members

  gboolean InboxFolder

    Whether it is really inbox.

  char Name[(GSM_MAX_MMS_FOLDER_NAME_LEN + 1) * 2]

    Name for MMS folder.

struct GSM_MMSFolders

  List of MMS folders.

  Public Members

  unsigned char Number

    Number of MMS folders.

  GSM_OneMMSFolder Folder[GSM_MAX_MMS_FOLDERS]

    Array of structures holding information about each folder.

enum EncodeMultiPartSMSID

  ID during packing SMS for Smart Messaging 3.0, EMS and other

  Values:

  enumerator SMS_Text

    1 text SMS.

  enumerator SMS_ConcatenatedTextLong

    Contacenated SMS, when longer than 1 SMS.

  enumerator SMS_ConcatenatedAutoTextLong

    Contacenated SMS, auto Default/Unicode coding.

  enumerator SMS_ConcatenatedTextLong16bit
  enumerator SMS_ConcatenatedAutoTextLong16bit
  enumerator SMS_NokiaProfileLong

    Nokia profile = Name, Ringtone, ScreenSaver

  enumerator SMS_NokiaPictureImageLong

    Nokia Picture Image + (text)

  enumerator SMS_NokiaScreenSaverLong

    Nokia screen saver + (text)

  enumerator SMS_NokiaRingtone

    Nokia ringtone - old SM2.0 format, 1 SMS

  enumerator SMS_NokiaRingtoneLong

    Nokia ringtone contacenated, when very long

  enumerator SMS_NokiaOperatorLogo

    Nokia 72x14 operator logo, 1 SMS

  enumerator SMS_NokiaOperatorLogoLong

    Nokia 72x14 op logo or 78x21 in 2 SMS

  enumerator SMS_NokiaCallerLogo

    Nokia 72x14 caller logo, 1 SMS

  enumerator SMS_NokiaWAPBookmarkLong

    Nokia WAP bookmark in 1 or 2 SMS

  enumerator SMS_NokiaWAPSettingsLong

    Nokia WAP settings in 2 SMS

  enumerator SMS_NokiaMMSSettingsLong

    Nokia MMS settings in 2 SMS

  enumerator SMS_NokiaVCARD10Long

    Nokia VCARD 1.0 - only name and default number

  enumerator SMS_NokiaVCARD21Long

    Nokia VCARD 2.1 - all numbers + text

  enumerator SMS_NokiaVCALENDAR10Long

    Nokia VCALENDAR 1.0 - can be in few sms

  enumerator SMS_NokiaVTODOLong
  enumerator SMS_VCARD10Long
  enumerator SMS_VCARD21Long
  enumerator SMS_DisableVoice
  enumerator SMS_DisableFax
  enumerator SMS_DisableEmail
  enumerator SMS_EnableVoice
  enumerator SMS_EnableFax
  enumerator SMS_EnableEmail
  enumerator SMS_VoidSMS
  enumerator SMS_EMSSound10

    IMelody 1.0

  enumerator SMS_EMSSound12

    IMelody 1.2

  enumerator SMS_EMSSonyEricssonSound

    IMelody without header - SonyEricsson extension

  enumerator SMS_EMSSound10Long

    IMelody 1.0 with UPI.

  enumerator SMS_EMSSound12Long

    IMelody 1.2 with UPI.

  enumerator SMS_EMSSonyEricssonSoundLong

    IMelody without header with UPI.

  enumerator SMS_EMSPredefinedSound
  enumerator SMS_EMSPredefinedAnimation
  enumerator SMS_EMSAnimation
  enumerator SMS_EMSFixedBitmap

    Fixed bitmap of size 16x16 or 32x32.

  enumerator SMS_EMSVariableBitmap
  enumerator SMS_EMSVariableBitmapLong
  enumerator SMS_MMSIndicatorLong

    MMS message indicator.

  enumerator SMS_WAPIndicatorLong
  enumerator SMS_AlcatelMonoBitmapLong

    Variable bitmap with black and white colors

  enumerator SMS_AlcatelMonoAnimationLong

    Variable animation with black and white colors

  enumerator SMS_AlcatelSMSTemplateName
  enumerator SMS_SiemensFile

    Siemens OTA

  enumerator SMS_USSD

struct GSM_MultiPartSMSEntry

  Entry of multipart SMS.

struct GSM_MultiPartSMSInfo

  Multipart SMS information.

enum MMSAddressType

  MMS address type.

  Values:

  enumerator MMSADDRESS_PHONE
  enumerator MMSADDRESS_UNKNOWN

struct GSM_EncodedMultiPartMMSEntry

  MMS entry.

  Public Members

  unsigned char ContentType[400]

    CT in Unicode

  unsigned char SMIL[400]

    Smil ID in Unicode

struct GSM_EncodedMultiPartMMSInfo

  MMS part.

  Public Members

  unsigned char Source[200]

    in Unicode

  unsigned char Destination[200]

    in Unicode

  unsigned char CC[200]

    in Unicode

  unsigned char Subject[200]

    in Unicode

  unsigned char ContentType[400]

    CT in Unicode

  unsigned char MSGType[50]

    no Unicode

  GSM_EncodedMultiPartMMSEntry Entries[GSM_MAX_MULTI_MMS]

    Subparts.